#ifdef _WIN32
#pragma warning( disable : 4996 )
#endif

#include <string.h>
#include <stdio.h>
#include <errno.h>
#include "grabber.h"

namespace {

#pragma pack(push)
#pragma pack(1)
struct S_BitmapInfoHeader {
	unsigned int size;
	int width;
	int height;
	unsigned short planes;
	unsigned short  bit_count;
	unsigned int compression;
	unsigned int cize_image;
	int  x_pels_per_meter;
	int  y_pels_per_meter;
	unsigned int clr_used;
	unsigned int clr_important;
};
#pragma pack(pop)

}

void C_Grabber::Init(const char *dir_name) {
	Zeroing();
	if(!dir_name || strlen(dir_name) >= sizeof(this->dir_name)) 
		throw "C_Grabber: invalid frame directory";

	char file_name[sizeof(this->dir_name) + 9];
#ifdef _WIN32
	sprintf(file_name, "%s\\0000.bmp", dir_name);
#else
	sprintf(file_name, "%s/0000.bmp", dir_name);
#endif
	FILE *file = fopen(file_name, "rb");
	if(!file)
		throw "C_Grabber: frame file opening error";
	fseek(file, 14, SEEK_SET);

	S_BitmapInfoHeader header;
	if(!fread(&header, sizeof(S_BitmapInfoHeader), 1, file))
		throw "C_Graber: invalid frame format";
	if(header.planes != 1 || header.bit_count != 8 || header.compression)
		throw "C_Graber: invalid frame format";

	fclose(file);

	frame_width = header.width;
	frame_height = header.height;

	strcpy(this->dir_name, dir_name);
}

void C_Grabber::GetFrame(unsigned char *frame_data) {
	if(!frame_data)
		return;

	char file_name[sizeof(this->dir_name) + 9];

#ifdef _WIN32
	sprintf(file_name, "%s\\%04u.bmp", dir_name, cur_frame);
#else
	sprintf(file_name, "%s/%04u.bmp", dir_name, cur_frame);
#endif
	
	FILE *file = fopen(file_name, "rb");
	if(!file && cur_frame) {
		cur_frame = 0;
		GetFrame(frame_data);
	}

	if(!file)
		return;
	fseek(file, 1078, SEEK_SET);

	unsigned char *cur = frame_data + (frame_width * (frame_height - 1));
	for(unsigned int i=0; i<frame_height; i++, cur -= frame_width)
		if(1 != fread(cur, frame_width, 1, file))
			break;

	fclose(file);
	
	cur_frame++;
}	
