#ifndef _AFFIXWIZARD_H_
#define _AFFIXWIZARD_H_

#include "tmkernel.h"

typedef struct tagS_AW_CamInternalParams {
	DWORD dwEffectivePixelsWidth;
	DWORD dwEffectivePixelsHeight;
	double dblCellWidth;
	double dblCellHeight;
	double dblFocus;
	double dblCameraHeight;
} S_AW_CamInternalParams;

#ifdef UNICODE
#define AW_LoadFromFile AW_LoadFromFileW 
#define AW_SaveToFile AW_SaveToFileW
#else
#define AW_LoadFromFile AW_LoadFromFileA 
#define AW_SaveToFile AW_SaveToFileA
#endif

#ifdef __cplusplus
extern "C" {
#endif
BOOL __stdcall AW_Show(HWND hwndOwner, const BYTE *pbImage, DWORD dwImageSize, S_TMKER_Affixment *pAffix, S_AW_CamInternalParams *pCIParams);
BOOL __stdcall AW_LoadFromFileA(const CHAR *szFileName, S_TMKER_Affixment *pAffix, S_AW_CamInternalParams *pCIParams);
BOOL __stdcall AW_LoadFromFileW(const WCHAR *szFileName, S_TMKER_Affixment *pAffix, S_AW_CamInternalParams *pCIParams);
BOOL __stdcall AW_SaveToFileA(const CHAR *szFileName, const S_TMKER_Affixment *pAffix, const S_AW_CamInternalParams *pCIParams);
BOOL __stdcall AW_SaveToFileW(const WCHAR *szFileName, const S_TMKER_Affixment *pAffix, const S_AW_CamInternalParams *pCIParams);
#ifdef __cplusplus
}
//! \}
#endif    
#endif